﻿using System.Windows;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.clearButton.Click    += clearButton_Click;
            this.addButton.Click      += addButton_Click;
            this.insertButton.Click   += insertButton_Click;
            this.containsButton.Click += containsButton_Click;
            this.letterButton.Click   += letterButton_Click;
            this.pageUpButton.Click   += pageUpButton_Click;
            this.pageDownButton.Click += pageDownButton_Click;
            this.scrollButton.Click   += scrollButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 지우기 버튼 클릭시 처리하기 - clearButton_Click(sender, e)

        /// <summary>
        /// 지우기 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void clearButton_Click(object sender, RoutedEventArgs e)
        {
            this.listControl.Clear();
        }

        #endregion
        #region 추가하기 버튼 클릭시 처리하기 - addButton_Click(sender, e)

        /// <summary>
        /// 추가하기 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void addButton_Click(object sender, RoutedEventArgs e)
        {
            this.listControl.Clear();

            for(int i = 200; i < 300; i++)
            {
                this.listControl.Add(i);
            }
        }

        #endregion
        #region 삽입하기 버튼 클릭시 처리하기 - insertButton_Click(sender, e)

        /// <summary>
        /// 삽입하기 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void insertButton_Click(object sender, RoutedEventArgs e)
        {
            for(int i = 199; i >= 100; i--)
            {
                this.listControl.Insert(0, i);
            }
        }

        #endregion
        #region 포함 여부 버튼 클릭시 처리하기 - containsButton_Click(sender, e)

        /// <summary>
        /// 포함 여부 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void containsButton_Click(object sender, RoutedEventArgs e)
        {
            bool result = this.listControl.Contains(250);

            MessageBox.Show("250 포함 여부 : " + result.ToString());
        }

        #endregion
        #region 글자로 이동 버튼 클릭시 처리하기 - containsButton_Click(sender, e)

        /// <summary>
        /// 글자로 이동 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void letterButton_Click(object sender, RoutedEventArgs e)
        {
            this.listControl.GoToLetter('2');

            this.listControl.ScrollIntoView();
        }

        #endregion
        #region 페이지 위 버튼 클릭시 처리하기 - pageUpButton_Click(sender, e)

        /// <summary>
        /// 페이지 위 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void pageUpButton_Click(object sender, RoutedEventArgs e)
        {
            this.listControl.PageUp();
        }

        #endregion
        #region 페이지 아래 버튼 클릭시 처리하기 - pageDownButton_Click(sender, e)

        /// <summary>
        /// 페이지 아래 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void pageDownButton_Click(object sender, RoutedEventArgs e)
        {
            this.listControl.PageDown();
        }

        #endregion
        #region 스크롤 버튼 클릭시 처리하기 - scrollButton_Click(sender, e)

        /// <summary>
        /// 스크롤 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void scrollButton_Click(object sender, RoutedEventArgs e)
        {
            this.listControl.SelectedIndex = this.listControl.Count - 1;

            this.listControl.ScrollIntoView();
        }

        #endregion
    }
}